name: test

on: [push, pull_request]

jobs:
  run-tests:
    runs-on: ${{ matrix.os }}
    defaults:
      run:
        shell: bash
    strategy:
      fail-fast: false
      matrix:
        os: [windows-latest, macos-latest, ubuntu-latest]
        python-version: ["3.7", "3.8", "3.9", "3.10", "3.11"]
    steps:
    - uses: actions/checkout@v2
    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v2
      with:
        python-version: ${{ matrix.python-version }}
    - name: Git configuration
      run: |
        git config core.autocrlf false
        git reset --hard
    - name: Build packages, and install the wheel
      run: |
        pip install build
        python -m build
        cd dist
        python -m pip install flake8_black-*.whl
        cd ..
        # Wheel should now be installed
        flake8 --version
    - name: Run tests
      run: |
        # Unpack the tests from the sdist tar-ball
        # (want to confirm the manifest was complete)
        tar -zxvf dist/flake8-black-*.tar.gz
        cd flake8-black-*/tests/
        WIN="$([ "$RUNNER_OS" == "Windows" ];echo $?)" bash ./run_tests.sh
